/*!************************************************************************************************
  @file file2c.c

  @brief  Converts a text file to a c file.

  Copyright 2021 Drew Gislason

  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and
  associated documentation files (the "Software"), to deal in the Software without restriction,
  including without limitation the rights to use, copy, modify, merge, publish, distribute,
  sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is
  furnished to do so, subject to the following conditions:

  The above copyright notice and this permission notice shall be included in all copies or
  substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT
  NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
  NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
  DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

  This just makes a very large NULL terminated string out of a file, in readable .c form.

  file2c <infile> <outfile> <varname>

*///***********************************************************************************************
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int main(int argc, const char *argv[])
{
  FILE   *fp;
  char   *pszBuf;
  char   *pszLine;
  char   *psz;
  char   *pszOut;
  long    len;
  long    escCount = 0;   // count # of \ characters needed
  int     maxLineLen = 0;
  int     ret;
  int     fLastLine = 0;

  if(argc < 4)
  {
    printf("\nUsage: file2c <infile> <outfile> <varname>\n");
    return 1;
  }

  // open the input file
  fp = fopen(argv[1], "r");
  if(!fp)
  {
    printf("\nErr: Can't open file '%s'\n", argv[1]);
    return 1;
  }

  // read in the input file
  fseek(fp, 0, SEEK_END);
  len = ftell(fp);
  rewind(fp);
  pszBuf = malloc(len + 1);
  if(!pszBuf)
  {
    printf("\nErr: Can't allocate %ld bytes of memory\n", len);
    return 1;
  }
  memset(pszBuf, 0, len + 1);
  if(fread(pszBuf, 1, len, fp) != len)
  {
    printf("\nErr: Can't read %ld bytes in file '%s'\n", len, argv[1]);
    return 1;
  }
  fclose(fp);

  // count number of \ characters needed to add
  psz = pszBuf;
  while(*psz)
  {
    if(*psz == '\\')
      ++escCount;
    if(*psz == '"')
      ++escCount;
    ++psz;
  }

  // create output file
  fp = fopen(argv[2], "w");
  if(!fp)
  {
    printf("\nErr: Can't create file '%s'\n", argv[2]);
    return 1;
  }
  if(fprintf(fp, "// AUTOGENERATED, DO NOT CHANGE\n// converted file '%s' to '%s'\n\nconst char %s[] = {\n",
      argv[1], argv[2], argv[3]) <= 0)
  {
    printf("\nErr: Can't write to file '%s'\n", argv[2]);
    return 1;
  }

  pszOut = malloc(len + escCount + 1);
  if(!pszOut)
  {
    printf("\nErr: Can't allocate %ld bytes of memory\n", len + escCount + 1);
    return 1;
  }
  memset(pszOut, 0, len + escCount + 1);

  // printf("%p '%s'", pszBuf, pszBuf);

  // write it out as lines
  psz = pszBuf;
  while(*psz)
  {
    // find end of line
    pszLine = pszOut;
    while(*psz && (*psz != '\n'))
    {
      if((*psz == '\\') || (*psz == '"'))
        *pszOut++ = '\\';
      if(*psz == '\r')
        *pszOut++ = '\0';
      else
        *pszOut++ = *psz;
      ++psz;
    }
    *pszOut = '\0';

    // last line, break
    if((*psz == '\0') || ((*psz == '\n') && (psz[1]=='\0')))
      fLastLine = 1;

    // /printf("fLastLine %i, pszBuf %p, psz %p, %c, pszLine '%s'\n", fLastLine, pszBuf, psz, *psz ? *psz : '~', pszLine);

    // don't write final \n
    if(fLastLine)
      ret = fprintf(fp, "  \"%s\"\n", pszLine);
    else
      ret = fprintf(fp, "  \"%s\\n\"\n", pszLine);

    // remember longest line (for later display)
    if(ret > maxLineLen)
      maxLineLen = ret;
    if(ret < 0)
    {
      printf("\nErr: Can't write to file '%s'\n", argv[2]);
      return 1;
    }

    if(fLastLine)
      break;

    // on to next line
    ++psz;
    ++pszOut;
  }

  // finish file
  if(fprintf(fp, "};\n") <= 0)
  {
    printf("\nErr: Can't write to file '%s'\n", argv[2]);
    return 1;
  }
  if(fclose(fp) != 0)
  {
    printf("\nErr: Can't finish file '%s'\n", argv[2]);
    return 1;
  }

  printf("Created file '%s', len %ld, maxLineLen %i\n", argv[2], len, maxLineLen);
  return 0;
}
